/*
** Dequote.c - part of GrabURL 2.0
** Copyright (C) 1996-97 Serge Emond
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdlib.h>
#include <string.h>
#include "libgurl.h"

/*
** Dequote
**  Removes quotes around a string, if any.
**  Quote types: ' and ".
**  Returns an array of char alloc'ed with malloc()
*/

char *Dequote(const char *str)
{
	char *p;
	int i;

	if (str[0]==34 || str[0]==39) {
	  p = strchr(str+1, str[0])+1;
	  if (!p) p=(char *)str + strlen(str);
	  
	  i = (int)p-(int)str - 2;
	  p = (char *)gmalloc(i+1);
	  strncpy(p, str+1, i);
	  p[i]=0;
	}
	else {
	  p = (char *)gmalloc(strlen(str)+2);
	  strcpy(p, str);
	}
	return(p);
}
